<?php
/**
 * Smart Forms jor Joomla
 * @license Released under the terms of the GNU General Public License v3
 **/

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
include_once(SMART_FORMS_DIR.'string_renderer/rednao_string_builder.php');


class php_entry_saver_base {
    private $FormId=null;
    private $FormEntryData=null;
    private $FormOptions=null;
    private $ElementOptions=null;
    private $Captcha=null;
    private $ReferenceId=null;
	private $EntryId="";
	private $FormString="";
	private $StringBuilder;
	private $InsertedValuesString=null;
    /**
     * @var SmartFormsAjax
     */
	private $ajax;


    function __construct($formId,$formString,$captcha,$referenceId="",$formOptions=null,$elementOptions=null)
    {
        include_once(SMART_FORMS_PUBLIC_DIR.'smart-forms-ajax.php');
        $this->ajax=new SmartFormsAjax();
        $this->FormId = $formId;
        $this->FormString=$formString;
        $this->FormEntryData = json_decode($this->FormString,true);
        $this->Captcha=$captcha;
        $this->ReferenceId=$referenceId;
		$this->FormOptions=$formOptions;
		$this->ElementOptions=$elementOptions;
		if($this->ElementOptions!=null)
		    $this->StringBuilder=new rednao_string_builder();
    }

    public function ProcessEntry($validateCaptcha=true,$additionalData=array())
    {
		if($this->FormOptions==null||$this->ElementOptions==null){
            $this->GetFormOptions();
            $this->StringBuilder=new rednao_string_builder();
        }


		if($this->FormEntryData==null)
		{
			return '{"message":"'."An error occurred, please try again later.".'","refreshCaptcha":"n","success":"n"}';
		}

        if($this->FormOptions["UsesCaptcha"]=="y"&&$validateCaptcha==true)
        {
			if($this->FormOptions["CaptchaVersion"]=="1")
				if(!$this->CaptchaIsValid2())
				{
					return  '{"message":"'.__("Invalid captcha.").'","refreshCaptcha":"y","success":"n"}';

				}

			$errorMessage="";
			if($this->FormOptions["CaptchaVersion"]=="2")
				if(!$this->CaptchaIsValid2($errorMessage))
				{
					return '{"message":"'.$errorMessage.'","refreshCaptcha":"y","success":"n"}';

				}
        }


		if(isset($_FILES)&&count($_FILES)>0)
		{
		    $errorMessage='';
			if(!$this->SaveFiles($errorMessage))
			{
				return json_encode(array(
				   'message'=> "An error occurred, please try again later.",
                    'success'=>'n',
                    'cause'=>$errorMessage
                ));
			}
		}

		require_once SMART_FORMS_DIR.'php_classes/save/insert_entry_base.php';
		require_once SMART_FORMS_DIR.'php_classes/save/pre_insert_entry.php';
		$this->ProcessSignatures();
		$preInsertedEntry=new PreInsertEntry($this->FormId,$this->FormEntryData,$this->FormOptions,$this->ElementOptions,$additionalData);
		SmartFormsActionManager::GetInstance()->DoAction('sf_before_saving_form',$preInsertedEntry);



		if(SmartFormsActionManager::GetInstance()->HasAction('sf_before_saving_form'))
		{
			$this->FormEntryData = $preInsertedEntry->FormEntryData;
			$this->FormString = json_encode($this->FormEntryData);
		}

		if($preInsertedEntry->ContinueInsertion==false)
		{
			return json_encode(
				array(
					"success"=>"n",
					"AdditionalActions"=>$preInsertedEntry->GetSerializedActions()
				)
			);
		}

		$this->InsertedValuesString=array();
       	$result=$this->ExecuteInsertions();
        if($this->FormOptions["SendNotificationEmail"]=="y")
		{
			foreach($this->FormOptions["Emails"] as $email)
            	$this->SendFormEmail($email,$this->FormEntryData,$this->ElementOptions,$preInsertedEntry, false);
		}


        if($result==true)
		{
			$postInsertEntry=new PreInsertEntry($this->FormId,$this->FormEntryData,$this->FormOptions,$this->ElementOptions,$additionalData);
			SmartFormsActionManager::GetInstance()->DoAction('sf_after_saving_form',$postInsertEntry);


			return json_encode(
				array(
					"message"=>"Information submitted successfully.",
					"success"=>"y",
					"AdditionalActions"=>$postInsertEntry->GetSerializedActions(),
					"insertedValues"=>array('_formid'=>$this->InsertedValuesString['_formid'])
				)
			);
		}
        else
		{
            return '{"message":"'."An error occurred, please try again later.".'","success":"n"}';
		}


    }

    private function ExecuteInsertions()
    {
        return $this->InsertEntryData();
    }

	public function GetFormElementsDictionary()
	{
		$formElementsDictionary =array();
		foreach($this->ElementOptions as $element)
			$formElementsDictionary[$element["Id"]]=$element;

		return $formElementsDictionary;
	}

    private function InsertEntryData(){
        if(isset($this->FormOptions['DisableDBStorage'])&&$this->FormOptions['DisableDBStorage']=='y')
        {
            $this->FormEntryData["_formid"]='';
            $this->InsertedValuesString["_formid"]='';
            return true;
        }


        $ip=$_SERVER['REMOTE_ADDR'];
        if(isset($this->FormOptions['DisableIPStorage'])&&$this->FormOptions['DisableIPStorage']=='y')
        {
            $ip='';
        }

        $formStringToSave=$this->FormString;
        if(SmartFormsOptionManager::GetInstance()->GetOption('SmartFormsEnableGDPR','n')=='y')
        {
            $formStringToSave=$this->RemoveDataProtectedFields(json_decode($this->FormString,true),$this->GetFormElementsDictionary());
            $formStringToSave=json_encode($formStringToSave);
        }

        $user = JFactory::getUser();
        $db=JFactory::getDBO();
        require_once (SMART_FORMS_PUBLIC_DIR.'smart-forms-db-helper.php');

        $result=SmartFormsDBHelper::Insert('#__smartforms_entry',
            array(
                'form_id'=>$this->FormId,
                'user_id'=>$user->id,
                'date'=>date('Y-m-d H:i:s'),
                'data'=>$formStringToSave,
                'ip'=>$ip,
                'reference_id'=>$this->ReferenceId
            ));



		if($result->getAffectedRows()==0)
			return false;
		$this->EntryId=$result->insertid();
        $this->FormEntryData["_formid"]=$this->EntryId;
		$this->InsertedValuesString["_formid"]=$this->EntryId;
		$result=$this->ParseAndInsertDetail($this->EntryId,$this->FormEntryData,$this->GetFormElementsDictionary());
		return $result;


    }

    private function RemoveDataProtectedFields($FormData, $formDictionary)
    {
        foreach($FormData as $key=>&$value)
        {
            if(!isset($formDictionary[$key]))
                continue;

            $field=$formDictionary[$key];
            if(isset($field['DoNotSave'])&&$field['DoNotSave']=='y')
            {
                unset($FormData[$key]);
                continue;
            }

            if($field['ClassName']=='rednaorepeater'&&isset($value['value']))
            {
                foreach($field['FieldOptions'] as $subFieldOptions)
                {
                    if(isset($subFieldOptions['DoNotSave'])&&$subFieldOptions['DoNotSave']=='y')
                    {
                        foreach($value['value'] as &$subValueRow)
                        {
                            foreach($subValueRow as $subValueFieldId=>$subValueFieldValue)
                            {
                                if(preg_match('/^'.$subFieldOptions['Id'].'_/',$subValueFieldId))
                                {
                                    unset($subValueRow[$subValueFieldId]);
                                }
                            }

                        }
                    }

                }

            }
        }

        return $FormData;

    }

    public function SendFormEmail($formOptions,$entryData,$elementOptions,$preInsertEntry,$useTestData)
    {
        if(isset($formOptions['Condition']))
        {
            $condition=$formOptions['Condition'];
            if(isset($condition['Use'])&&$condition['Use']=='condition')
            {
                require_once SMART_FORMS_DIR.'php_classes/condition_parser/condition_parser.php';
                $conditionParser=new SFConditionParser($preInsertEntry);
                $conditionSettings=$condition['ConditionSettings'];
                if(!$conditionParser->IsTrue($conditionSettings['Conditions']))
                    return true;
            }

        }
        $EmailText=$formOptions["EmailText"];
        $FromName=$formOptions["FromName"];
        $FromEmail=$formOptions["FromEmail"];
        $ToEmail=$formOptions["ToEmail"];
        $EmailSubject=$formOptions["EmailSubject"];
        $Bcc='';

        if(isset($formOptions["Bcc"]))
            $Bcc=$formOptions["Bcc"];

        if(isset($formOptions['ReplyTo']))
            $ReplyTo=$formOptions['ReplyTo'];
        else
            $ReplyTo=$FromEmail;




        if($EmailSubject=="")
            $EmailSubject="Form Submitted";


        $fieldPattern='/\\[field ([^\\]]+)/';
        preg_match_all($fieldPattern,$EmailText, $matches, PREG_PATTERN_ORDER);

        require_once(SMART_FORMS_DIR.'php_classes/save/smarty_custom_code/smarty_email_generator.php');
        $smarty=new smarty_email_generator();
        try{
            $EmailText=$smarty->AttemptToProcessEmailString($elementOptions,$EmailText,$matches,$entryData,$useTestData);
        }catch (Exception $e)
        {
            foreach($matches[1] as $match)
            {
                $value=$this->ajax-> GetValueByField($this->StringBuilder,$match,$entryData,$elementOptions,$useTestData);
                $EmailText=str_replace("[field $match]",$value,$EmailText);
            }
        }




        if(strpos($FromName,"[field")!==false)
        {
            preg_match_all($fieldPattern,$FromName, $matches, PREG_PATTERN_ORDER);
            foreach($matches[1] as $match)
            {
                $value=$this->ajax->GetValueByField($this->StringBuilder,$match,$entryData,$elementOptions,$useTestData);
                $FromName=str_replace("[field $match]",$value,$FromName);
            }
        }

		if(strpos($EmailSubject,"[field")!==false)
		{
			preg_match_all($fieldPattern,$EmailSubject, $matches, PREG_PATTERN_ORDER);
			foreach($matches[1] as $match)
			{
				$value=$this->ajax->GetValueByField($this->StringBuilder,$match,$entryData,$elementOptions,$useTestData);
				$EmailSubject=str_replace("[field $match]",$value,$EmailSubject);
			}
		}


		if(strpos($FromEmail,"[field")===0)
		{
			preg_match_all($fieldPattern,$FromEmail, $matches, PREG_PATTERN_ORDER);
			if(count($matches[1])>0)
			{
				$field=$matches[1][0];
				$value=$this->ajax->GetValueByField($this->StringBuilder,$field,$entryData,$elementOptions,$useTestData);
				$FromEmail=$value;
			}else{
				$FromEmail="";

			}

		}

        if(strpos($ReplyTo,"[field")===0)
        {
            preg_match_all($fieldPattern,$ReplyTo, $matches, PREG_PATTERN_ORDER);
            if(count($matches[1])>0)
            {
                $field=$matches[1][0];
                $value=$this->ajax->GetValueByField($this->StringBuilder,$field,$entryData,$elementOptions,$useTestData);
                $ReplyTo=$value;
            }else{
                $ReplyTo="";

            }

        }

        if(strpos($Bcc,"[field")===0)
        {
            preg_match_all($fieldPattern,$Bcc, $matches, PREG_PATTERN_ORDER);
            if(count($matches[1])>0)
            {
                $field=$matches[1][0];
                $value=$this->ajax->GetValueByField($this->StringBuilder,$field,$entryData,$elementOptions,$useTestData);
                $Bcc=$value;
            }else{
                $Bcc="";

            }

        }

        $config = JFactory::getConfig();
        if($FromEmail=='')
        {
            $FromEmail=$config->get('mailfrom');
        }

        if($FromName=="")
        {
            $FromName = $config->get('fromname');
        }

        if($ToEmail==="")
        {
            $ToEmail=$config->get('mailfrom');
        }

		$headers = 'MIME-Version: 1.0' . "\r\n";
        $headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";
        $headers.= "From: ".$this->SanitizeName($FromName)." <$FromEmail>". "\r\n";
        if($Bcc!='')
            $headers.= "Bcc: $Bcc\r\n";
        if($ReplyTo!='')
		    $headers.= "Reply-To: $FromName <$ReplyTo>";
        if(trim($ToEmail)!="")
        {

			$toEmailArray=explode(",",$ToEmail);
            $finalToEmails=array();
			for($i=0;$i<count($toEmailArray);$i++)
			{
				if(strpos($toEmailArray[$i],"[field")===0)
				{
					preg_match_all($fieldPattern,$toEmailArray[$i], $matches, PREG_PATTERN_ORDER);
					if(count($matches[1])>0)
					{
						$field=$matches[1][0];

						//$value=GetValueByField($this->StringBuilder,$field,$entryData,$elementOptions,$useTestData);
                        $value=$this->GetEmailsFromField($formOptions, $field,$preInsertEntry);
						$toEmailArray=array_merge($toEmailArray,$value);
					}


				}else
                {
                    if(trim($toEmailArray[$i])!="")
                        array_push($finalToEmails,$toEmailArray[$i]);
                }

			}
			$toEmailArray=array_filter($toEmailArray);

            $emailParams=array(
                            "EmailContent"=>array(
                                "ToEmail"=>$finalToEmails,
                                "Subject"=>$EmailSubject,
                                "EmailText"=>$EmailText,
                                "Headers"=>$headers,
                                "Attachments"=>Array()
                            ),
                            "FormOptions"=>$formOptions,
							"InsertEntry"=>$preInsertEntry
                        );


            $emailParams=SmartFormsFilterManager::GetInstance()->ApplyFilter('smart_forms_before_sending_email',$emailParams);
			$emailContent=$emailParams["EmailContent"];
            $mail = JFactory::getMailer();
            $mail->setSender(array($FromEmail,$FromName));
            $mail->setSubject($emailContent["Subject"]);
            $mail->setBody($emailContent["EmailText"]);
            $mail->IsHTML(true);
            $mail->addRecipient($emailContent["ToEmail"]);
            $mail->addReplyTo($ReplyTo);

            if(isset($emailContent['Attachments']))
            {
                foreach($emailContent['Attachments'] as $attachment)
                    $mail->addAttachment($attachment);
            }
            if($Bcc!='')
            {
                $mail->addBcc($Bcc);
            }
            $result= $mail->send();
            SmartFormsActionManager::GetInstance()->DoAction('smart_forms_after_sending_email');
            if($result instanceof JException)
            {
                return false;
            }
            return $result;/*



            $result= wp_mail($emailContent["ToEmail"],$emailContent["Subject"],$emailContent["EmailText"],$emailContent["Headers"],$emailContent["Attachments"]);*/

            //return $result;
        }

        return false;
    }

    private function SanitizeName($name)
    {
        $rule = array("\r" => '',
            "\n" => '',
            "\t" => '',
            '"'  => "'",
            '<'  => '[',
            '>'  => ']',
        );

        return trim(strtr($name, $rule));
    }

    private function GetEmailsFromField($emailOptions,$fieldId,$preInsertEntry)
    {
        $fieldData=$preInsertEntry->GetField($fieldId);
        if($fieldData["ClassName"]=="rednaomultipleradios"||$fieldData["ClassName"]=="rednaomultiplecheckboxes"
            ||$fieldData["ClassName"]=="rednaoselectbasic"||$fieldData["ClassName"]=="rednaosearchablelist")
        {
            $selectedValues= $preInsertEntry->GetFieldValue($fieldId, SFSerializationType::ARRAYLIST);
            if(!isset($emailOptions["MultipleOptionsToEmails"][$fieldId]))
                return array();
            $emailsToReturn=array();
            $optionsToEmail=$emailOptions["MultipleOptionsToEmails"][$fieldId];
            foreach($selectedValues as $selectedValue)
                foreach($optionsToEmail as $optionToEmail)
                {
                    if ($selectedValue["label"] == $optionToEmail["Label"])
                    {
                        $emails = $optionToEmail["EmailTo"];
                        if (trim($emails) == "")
                            continue;
                        $emailsToReturn = array_merge($emailsToReturn, explode(",", $emails));
                    }
                }

            return $emailsToReturn;


        }
        else
        {
            $text=$preInsertEntry->GetFieldValue($fieldId, SFSerializationType::TEXT);
            if(trim($text)=="")
                return array();
            else
                return array($text);

        }


    }



	private function CaptchaIsValid2(&$errorMessage)
	{
		$errorMessage="Invalid captcha";
		$Message="";
		if($this->Captcha==""||$this->Captcha==null||$this->Captcha["response"]=="")
			return false;

		$captchaPost=$this->Captcha;
		$captcha=ARRAY();
		$captcha["response"]=$captchaPost["response"];
		$captcha["remoteip"]=$_SERVER['REMOTE_ADDR'];
		$captcha["secret"]=$this->FormOptions['FieldServerOptions']['captcha2']['SecretKey'];


        $curlConfig = array( CURLOPT_URL => 'https://www.google.com/recaptcha/api/siteverify', CURLOPT_POST => true, CURLOPT_RETURNTRANSFER => true, CURLOPT_POSTFIELDS => $captcha ,CURLOPT_SSL_VERIFYPEER=>false);
        $ch = curl_init();
        curl_setopt_array($ch, $curlConfig);
        $response = curl_exec($ch);
        curl_close($ch);
        $response = json_decode($response,true);

		if($response["success"]===true)
			return true;
		if($response["error-codes"][0]=="invalid-input-secret")
			$errorMessage="Invalid secret key";

		return false;
	}

    private function GetFormOptions()
    {
        $db=JFactory::getDBO();
        $db->setQuery("select form_options,element_options from #__smartforms where form_id=".$db->quote($this->FormId));
        $result=$db->loadObjectList();

        if(count($result)>0){
            $this->FormOptions=json_decode($result[0]->form_options,true);
            $this->ElementOptions=json_decode($result[0]->element_options,true);
        }
    }

	private function SaveFiles(&$errorMessage)
	{
		require_once(SMART_FORMS_DIR . "php_classes/file_upload/physical_file_uploader.php");
		$fileUploader=new physical_file_uploader();
		$result= $fileUploader->UploadFiles($this->FormEntryData);
		if($result["success"]==true)
		{
			$this->FormEntryData=$result["entryData"];
			$this->FormString=json_encode($result["entryData"]);
			return true;
		}
		else
		    $errorMessage=$result['cause'];
		return false;
	}

	private function DeleteInsertedEntry()
	{
		global $wpdb;
		$wpdb->query($wpdb->prepare("delete from ".SMART_FORMS_ENTRY." WHERE entry_id=%d",$this->EntryId));
	}

	public function ParseAndInsertDetail($entryId,$entryData,$formElementsDictionary)
	{

		foreach($entryData as $key=>$unprocessedValue)
		{
			if(!isset($formElementsDictionary[$key]))
				continue;

			$fieldConfiguration=$formElementsDictionary[$key];
			$value=$this->StringBuilder->GetStringFromColumn($fieldConfiguration,$unprocessedValue);
			if($fieldConfiguration["ClassName"]!="sfFileUpload")
				$this->InsertedValuesString[$key]=$value;
			$exValue=$this->StringBuilder->GetExValue($fieldConfiguration,$unprocessedValue);
			$dateValue=$this->StringBuilder->GetDateValue($fieldConfiguration,$unprocessedValue);
			if($dateValue!=null)
				$dateValue=date('Y-m-d',$dateValue);
			$jsonValue=json_encode($unprocessedValue);
			if(!$this->InsertDetailRecord($entryId,$key,$value,$jsonValue,$exValue,$dateValue))
				return true;
		}

		return true;
	}

	private function InsertDetailRecord($entry_id, $fieldId, $value, $jsonValue,$exValue,$dateValue)
	{


        global $wpdb;
		$arrayToInsert=array_merge(array(
			"entry_id"=>$entry_id,
			"field_id"=>$fieldId,
			"json_value"=>$jsonValue,
			"value"=>$value
		),$exValue);
        if($dateValue!=null)
            $arrayToInsert["datevalue"]=$dateValue;
        $result=SmartFormsDBHelper::Insert('#__smart_forms_entry_detail',
            $arrayToInsert);


		return $result->getAffectedRows()>0;
	}

	private function GetSignatureNewName(){
        $i=1;
        $finalFileName='';
        $fileName=uniqid().'.svg';
        $destination=JPATH_SITE .'/media/smartforms/signatures/';
        $finalName=$fileName;
        $p=1;
        while(file_exists( $destination.$finalName))
        {
            $finalName=$fileName.'_'.$p;
            $p++;
        }

        return $finalName;
    }

    private function ProcessSignatures()
    {

        foreach ($this->FormEntryData as $key=>&$currentEntryItem)
        {
            foreach($this->ElementOptions as $currentElement)
            {
                if($currentElement['Id']==$key&&$currentElement['ClassName']=='rednaosignature')
                {
                    $result=$this->SaveSignature($currentEntryItem['value']);
                    if($result['status']==false)
                        return $result['error'];
                    $currentEntryItem['reference']=$result['result'];
                    $currentEntryItem['url']=JUri::root( false ) . 'media/smartforms/signatures/'.  $result['result'];
                }

                if($currentElement['Id']==$key&&$currentElement['ClassName']=='rednaorepeater')
                {
                    $repeaterValues=&$currentEntryItem['value'];
                    foreach($repeaterValues as &$repeaterRow)
                    {
                        foreach($repeaterRow as $repeaterItemKey=>&$repeaterItemValue)
                        {
                            $matches=array();
                            preg_match('/(.*)_row_\d*/', $repeaterItemKey,$matches);
                            if(count($matches)!=2)
                                continue;

                            $fieldId=$matches[1];
                            foreach($currentElement['FieldOptions'] as $repeaterField)
                            {
                                if($repeaterField['Id']==$fieldId&&$repeaterField['ClassName']=='rednaosignature')
                                {
                                    $result = $this->SaveSignature($repeaterItemValue['value']);
                                    if ($result['status'] == false)
                                        return $result['error'];
                                    $repeaterItemValue['reference'] = $result['result'];
                                    $repeaterItemValue['url']=JUri::root( false ) . 'media/smartforms/signatures/'.  $result['result'];
                                }
                            }
                        }
                    }


                }
            }
        }

        return true;

    }

    private function SaveSignature($data)
    {
        $fileName=$this->GetSignatureNewName();
        //$data=str_replace(' ','+',$data);
        $data=base64_decode($data);
        $path=JPATH_SITE .'/media/smartforms/signatures/';

        if ( !JFolder::exists( $path ) ) {
            if(!@JFolder::create( $path ))
               return array('status'=>false,'error'=>'Could not create signature folder');
        }

        $destination=JPATH_SITE .'/media/smartforms/signatures/';
        $fileName=JFile::makeSafe($fileName);

        if(@file_put_contents( $destination.$fileName,$data)===false)
        {
            return array('status'=>false,'error'=>'JFile failed to upload the signature');

        }
        return array('status'=>true,'result'=>$fileName);
    }


}

function SmartFormsOverwriteHandleUpload($upload)
{

}

function GetPHPFormula($formula)
{
	$fieldPattern='/\\[field ([^\\]]+)/';
	preg_match_all($fieldPattern,$formula, $matches, PREG_PATTERN_ORDER);

	foreach($matches[1] as $match)
	{
		$formula=str_replace("[field $match]","formData[$match]['amount']",$formula);
	}

	return $formula;
}

function SmartFormsGetFormattedFormValues($formValues,$elementOptions)
{
	include_once(SMART_FORMS_DIR.'string_renderer/rednao_string_builder.php');
	include_once(SMART_FORMS_DIR.'smart-forms-ajax.php');
	$stringBuilder=new rednao_string_builder();
	$processedData=array();
	foreach($formValues as $key=>$value)
	{
		$element=null;
		foreach($elementOptions as $item)
		{
			if($item["Id"]==$key)
			{
				$element=$item;
				break;
			}
		}

		if($element!=null)
		{
			 $processedData[]=array("name"=>$element["Label"],
			 						"value"=>$stringBuilder->GetStringFromColumn($element,$value));
		}
	}

	return $processedData;

}